include masm32rt.inc
include \masm32\macros\timers.asm
.686p
.mmx
.xmm

fpuSetPrecision macro mem16:=<WORD ptr [esp-2]>,prec:=<REAL8>
	IFIDNI <&prec>,<REAL4>
		fstcw mem16
		and mem16,0fCffh
		fldcw mem16
	ELSEIFIDNI <&prec>,<REAL8>
		fstcw mem16
		and mem16,0fCffh
		or mem16,0200h
		fldcw mem16
	ELSEIFIDNI <&prec>,<REAL10>
		fstcw mem16
		or mem16,0300h
		fldcw mem16
	ELSE
		.err <invalid precision specifier: &prec>
	ENDIF
endm

.data
	x			REAL4 -12.5663706143591		; -4*pi
	c0			REAL4 0.003068336128521		; 8*pi/(%lengthof test_array-1)
.data?	
	test_array 	REAL4 8*1024 dup (?)
	hFile 		dd ?	
	y			REAL4 ?
	y2			REAL8 ?
	sz1			db 128 dup (?)
	sz2			db 128 dup (?)
	vcrt		dd ?
.code
start:

	.if !ASM(mov esi,rv(LoadLibrary,"msvcrt.dll")) || !ASM(mov edi,rv(GetProcAddress,esi,"__libm_sse2_sinf"))
		print "__libm_sse2_sinf not available",10,13
	.else
		mov vcrt,1	
	.endif
	

	; calc x-values from -4*pi ... +4*pi
	mov ecx,lengthof test_array
	mov edx,OFFSET test_array
	fld c0
	.repeat
		m2m DWORD ptr [edx],x
		fld x
		fadd st,st(1)
		fstp x
		lea edx,[edx+4]
		dec ecx
	.until ZERO?
	ffree st

	mov hFile,fcreate("fpu_sse2_diff.csv")
	mov esi,OFFSET test_array
	mov ebx,lengthof test_array
	align 16
@@:	fpuSetPrecision ,REAL4
	fld REAL4 ptr [esi]
	fst x
	fsin
	movss xmm0,REAL4 ptr [esi]
	call sinss
	movd y,xmm0
	fld y
	fsubrp st(1),st
	fstp  y2
	mov sz1[0],0
	mov sz2[0],0
	fn crt_sprintf,OFFSET sz2,"%-.8f",y2
	fprint hFile,cat$(OFFSET sz1,real4$(x),";",OFFSET sz2,chr$(13,10))
	lea esi,[esi+4]
	dec ebx
	jnz @B
@@:	fclose hFile

	.if vcrt
		mov hFile,fcreate("fpu_CRT_SSE2_diff.csv")
		mov esi,OFFSET test_array
		mov ebx,lengthof test_array
		align 16
	@@:	fpuSetPrecision ,REAL4
		fld REAL4 ptr [esi]
		fst x
		fsin
		movss xmm0,REAL4 ptr [esi]
		call edi	; __libm_sse2_sinf
		movd y,xmm0
		fld y
		fsubrp st(1),st
		fstp  y2
		mov sz1[0],0
		mov sz2[0],0
		fn crt_sprintf,OFFSET sz2,"%-.8f",y2
		fprint hFile,cat$(OFFSET sz1,real4$(x),";",OFFSET sz2,chr$(13,10))
		lea esi,[esi+4]
		dec ebx
		jnz @B
	@@:	fclose hFile
	.endif

	print "sine aproximation vs. FPU vs. VCRT (REAL4)",10,13
	counter_begin 10000, HIGH_PRIORITY_CLASS
		fpuSetPrecision ,REAL4
		mov esi,OFFSET test_array
		mov ecx,lengthof test_array
		align 16
	@@:
		fld REAL4 ptr [esi]
		movss xmm0,REAL4 ptr [esi]
		fsin
		fstp st
		lea esi,[esi+4]
		dec ecx
		jnz @B
	@@:	
	counter_end
	shr eax,13
	print str$(eax), 9, "fpu", 13, 10

	.if vcrt
		counter_begin 10000, HIGH_PRIORITY_CLASS
			fpuSetPrecision ,REAL4
			mov esi,OFFSET test_array
			mov ecx,lengthof test_array
			align 16
		@@:
			fld REAL4 ptr [esi]
			movss xmm0,REAL4 ptr [esi]
			call edi 	; __libm_sse2_sinf
			fstp st
			lea esi,[esi+4]
			dec ecx
			jnz @B
		@@:	
		counter_end
		shr eax,13
		print str$(eax), 9, "VCRT SSE2", 13, 10
	.endif

	counter_begin 10000, HIGH_PRIORITY_CLASS
		fpuSetPrecision ,REAL4
		mov esi,OFFSET test_array
		mov edi,lengthof test_array
		align 16
	@@:
		fld REAL4 ptr [esi]
		movss xmm0,REAL4 ptr [esi]
		call sinss
		fstp st
		lea esi,[esi+4]
		dec edi
		jnz @B
	@@:	
	counter_end
	shr eax,13
	print str$(eax), 9, "SSE2", 13, 10

	inkey
	exit
;-----------------------------------------------------------------------------
; calculates the sine frome the low order float value in xmm0
; IN/OUT: low float value in xmm0
;-----------------------------------------------------------------------------
; sine approximation based on the taylor series for:
; 	f(x) = sin(x*(pi/2))  with   -1 <= x <= 1
; 
; 	T(x) = 1/2*x*pi - 1/48*x^3*pi^3 + 1/3840*x^5*pi^5 - 1/645120*x^7*pi^7 ...
;	T(x) = x*(1-(u/6)*(1-(u/20)*(1-(u/42)*(1-(u/72)*[1 - ...])))) 
;	with u = (x*pi)/4
;
OPTION PROLOGUE:none
OPTION EPILOGUE:none
align 16
sinss proc
	
	sinss_const SEGMENT page read	; for the alignment
		sinss_2_pi	REAL8  0.6366197723675813430755351	; 2/pi
		sinss_05pi  REAL8  1.5707963267948966192313217	; 0.5*pi 

		sinss_qdrnt	REAl4  0.0
					REAl4  1.0
					REAl4  0.0
					REAl4 -1.0

		sinss_c3 	REAL8 -0.03426945972600471742650865	; (pi^2)/(4*72)
		sinss_c2 	REAl8 -0.05874764524457951558830054	; (pi^2)/(4*42)
		sinss_c1 	REAL8 -0.12337005501361698273543114	; (pi^2)/(4*20)
		sinss_c0 	REAL8 -0.41123351671205660911810379	; (pi^2)/(4*6)
	sinss_const ENDS

	cvtss2sd xmm0,xmm0
	mulsd xmm0,sinss_2_pi
	cvttsd2si eax,xmm0
	cvtsi2sd xmm1,eax
	mov edx,eax
	subsd xmm0,xmm1	
	and edx,3
	jz @calc
	movsd xmm1,xmm0
	cvtss2sd xmm0,sinss_qdrnt[edx*4]

	and eax,80000003h
	js @s
	jnp @np
	jp @p
@s:	test eax,2
	jz @p
@np:	subsd xmm0,xmm1
	jmp @calc	
@p:		addsd xmm0,xmm1
@calc:

	movsd xmm2,xmm0
	cvtss2sd xmm1,sinss_qdrnt[4]
	movsd xmm3,sinss_c3
	mulsd xmm2,xmm2
	mulsd xmm3,xmm2
	addsd xmm3,xmm1
	mulsd xmm0,sinss_05pi
	
	mulsd xmm3,xmm2
	mulsd xmm3,sinss_c2
	addsd xmm3,xmm1
	     
	mulsd xmm3,xmm2
	mulsd xmm3,sinss_c1
	addsd xmm3,xmm1
	     
	mulsd xmm3,xmm2
	mulsd xmm3,sinss_c0
	addsd xmm3,xmm1
	     
	mulsd xmm0,xmm3
	cvtsd2ss xmm0,xmm0

	ret

sinss endp
OPTION PROLOGUE:prologuedef
OPTION EPILOGUE:epiloguedef

end start